<?php
	// Experimental extended version
	require_once( K_COUCH_DIR.'addons/phpmailer/Html2Text.php' );

    class KPHPMailer{

        var $config = array();

        function KPHPMailer(){
            global $FUNCS;

            // hook onto event thrown by $FUNCS->send_mail() function
            $FUNCS->add_event_listener( 'alter_send_mail', array($this, 'send_mail_handler') );

            $this->populate_config();
        }

        function populate_config(){
            $cfg = array();
            if( file_exists(K_COUCH_DIR.'addons/phpmailer/config.php') ){
                require_once( K_COUCH_DIR.'addons/phpmailer/config.php' );
            }

            $this->config = array_map( "trim", $cfg );
            unset( $cfg );
        }

        function send_mail_handler( &$from, &$to, &$subject, &$text, &$headers, &$result, &$attachment ){
            global $FUNCS;

            //require K_COUCH_DIR . 'addons/phpmailer/PHPMailer/PHPMailerAutoload.php';
            require_once K_COUCH_DIR . 'addons/phpmailer/PHPMailer/PHPMailerAutoload.php';
            $mail = new PHPMailer;

            switch( strtolower($this->config['method']) ){
                case 'smtp':
                    $mail->IsSMTP();
                        if( $this->config['host'] ){   $mail->Host = $this->config['host']; }
                        if( $this->config['port'] ){   $mail->Port = $this->config['port']; }
                        if( $this->config['secure'] ){ $mail->SMTPSecure = $this->config['secure']; }
                        if( $this->config['authentication_required'] ){
                            $mail->SMTPAuth = true;
                            $mail->Username = $this->config['username'];
                            $mail->Password = $this->config['password'];
                        }
                    break;
                case 'mail':    $mail->isMail(); break;
                case 'sendmail':$mail->isSendmail(); break;
                case 'qmail':   $mail->isQmail();
            }

            // from
            $arr_addr = $mail->parseAddresses( $from );
            $mail->SetFrom( $arr_addr[0]['address'], $arr_addr[0]['name'] );

            // to
            $arr_addr = $mail->parseAddresses( $to );
            for( $x=0; $x<count($arr_addr); $x++ ){
                $mail->addAddress( $arr_addr[$x]['address'], $arr_addr[$x]['name'] );
            }

            // cc, bcc, reply-to
            if( is_array($headers) ){
                foreach( $headers as $k=>$v ){
                    switch( $k ){
                        case 'Cc':
                            $arr_addr = $mail->parseAddresses( $v );
                            for( $x=0; $x<count($arr_addr); $x++ ){
                                $mail->addCC( $arr_addr[$x]['address'], $arr_addr[$x]['name'] );
                            }
                            break;
                        case 'Bcc':
                            $arr_addr = $mail->parseAddresses( $v );
                            for( $x=0; $x<count($arr_addr); $x++ ){
                                $mail->addBCC( $arr_addr[$x]['address'], $arr_addr[$x]['name'] );
                            }
                            break;
                        case 'Reply-To':
                            $arr_addr = $mail->parseAddresses( $v );
                            for( $x=0; $x<count($arr_addr); $x++ ){
                                $mail->AddReplyTo( $arr_addr[$x]['address'], $arr_addr[$x]['name'] );
                            }
                            break;
                        case 'Return-Path':
                        case 'MIME-Version':
                            break;
                        case 'Content-Type':
                            if( ($pos=strripos($v, 'charset=')) !== false ){
                                // expects string in the format 'text/html; charset=utf-8' as dispatched by cms:send_mail tag
                                $charset = substr( $v, $pos + 8);
                                $mail->CharSet = $charset;
                            }

                            if( stripos($v, 'html') !== false ){
                                $mail->isHTML( true );
                            }
                            break;
                        default:
                            $mail->addCustomHeader( $k, $v );
                            break;
                    }
                }
            }

            // subject and body
            $mail->Subject  = $subject;
            $mail->Body     = $text;
			
			// Experimental simple version
            //$mail->AltBody  = preg_replace( "/\n\s+/", "\n", rtrim(html_entity_decode(strip_tags($text))) );

			// Experimental extended version
			$plaintext = new \Html2Text\Html2Text($text);
			$mail->AltBody  = $plaintext->getText();

            // debug?
            if( $this->config['debug'] ){
                $mail->SMTPDebug = 1;
                $mail->Debugoutput = array( $this, 'log_debug' );
                ob_start();
            }

            // Attachment
            if( file_exists ( $attachment ) ){
                $mail->AddAttachment( $attachment );
            }

            // aaand send it!
            $result = $mail->send();

            if( $this->config['debug'] ){
                $log = ob_get_contents();
                ob_end_clean();
                $FUNCS->log( $log );
            }

            return 1; // tell $FUNCS to skip any further processing of the function call
        }

        function log_debug( $str, $level ){
            global $FUNCS;

            $str = preg_replace('/(\r\n|\r|\n)/ms', "\n", $str);
            echo str_replace(
                "\n",
                "\n                   \t                  ",
                trim($str)
            ) . "\n";
        }

    }// end class

    $KPHPMailer = new KPHPMailer();
